"use strict";
/**
 * @module RobotJS
 */
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const rpscript_interface_1 = require("rpscript-interface");
const ramda_1 = __importDefault(require("ramda"));
var robot = require('robotjs');
let RPSRobotjs = class RPSRobotjs {
    keyboard(ctx, opts, text) {
        return new Promise((resolve, reject) => {
            let result = undefined;
            const options = ramda_1.default.merge(KEYBOARD_DEFAULT, opts);
            if (options.tap)
                result = robot.keyTap(text, options.tapModifier);
            else if (options.toggle)
                result = robot.keyToggle(text, options.toggle);
            else
                result = robot.typeStringDelayed(text, options.delay);
            resolve(result);
        });
    }
    mouse(ctx, opts, x, y) {
        return new Promise((resolve, reject) => {
            let result = undefined;
            const options = ramda_1.default.merge(MOUSE_DEFAULT, opts);
            if (options.click)
                result = robot.mouseClick(options.button, options.doubleClick);
            else if (options.drag)
                result = robot.mouseDrag(x, y);
            else if (options.scroll)
                result = robot.mouseScroll(x, y);
            else if (options.toggle)
                result = robot.mouseToggle(options.down, options.button);
            else if (options.smooth)
                result = robot.moveMouseSmooth(x, y);
            else
                result = robot.moveMouse(x, y);
            resolve(result);
        });
    }
    desktopInfo(ctx, opts) {
        return new Promise((resolve, reject) => {
            let mousePos = robot.getMousePos();
            let pixelColor = robot.getPixelColor(mousePos.x, mousePos.y);
            let screensize = robot.getScreenSize();
            resolve({
                mousePosition: mousePos, pixelColor: pixelColor, screenSize: screensize
            });
        });
    }
};
__decorate([
    rpscript_interface_1.rpsAction({ defaultName: 'keyboard' })
], RPSRobotjs.prototype, "keyboard", null);
__decorate([
    rpscript_interface_1.rpsAction({ defaultName: 'mouse' })
], RPSRobotjs.prototype, "mouse", null);
__decorate([
    rpscript_interface_1.rpsAction({ defaultName: 'desktopInfo' })
], RPSRobotjs.prototype, "desktopInfo", null);
RPSRobotjs = __decorate([
    rpscript_interface_1.RpsModule("robotjs")
], RPSRobotjs);
exports.default = RPSRobotjs;
const KEYBOARD_DEFAULT = { delay: 800, tap: false, toggle: '', tapModifier: [] };
const MOUSE_DEFAULT = {
    smooth: false, click: false, toggle: false, drag: false, scroll: false,
    button: 'left', doubleClick: false, down: 'down'
};
